#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <iconv.h>
#include "x000_sd.h"

/*---------------------------------------------
 * ̾ꥹȽ 
 *   MGRեԽϤ
 *---------------------------------------------*/
int outputMgrFile(trackInfo track[], fileInfo *file, int trackNum){
	mgrFile out;	/* MGRե */
	int	i, j;
	int	mgrFileNum, mgrDataNum;
	char	buf[MAX_LEN];

	char	hex[3];
	char	*endp;
	unsigned long workl;


	/*  */
	memset(&out, NULL, sizeof(out));
	memset(&buf, NULL, sizeof(buf));
	memcpy(&buf, HEADER, sizeof(HEADER));

	/* إå */
	for(i = 0; i < HEAD_DAT; i++){
		hex[0] = buf[i * 2    ];
		hex[1] = buf[i * 2 + 1];
		hex[2] = 0;
		workl = strtol((char*)hex, &endp, 16);
		out.head.dat[i] = workl;
	}

	/*  */
	mgrFileNum = 0;
	mgrDataNum = 0;
	for(i = 0; i < trackNum; i++){

		/* 100ĶƤǡ */
		if(mgrDataNum >= 100){
			/* ե */
			outputFile(&(out), file, mgrFileNum);

			/*  */
			mgrFileNum++;
			mgrDataNum = 0;
		}
		
		/* ǡ */
		setMgrData(&(track[i]), &(out.data[mgrDataNum]), i);
		mgrDataNum++;
		
	}

	/* Ĥʬ */
	for(i = trackNum; i < (mgrFileNum + 1) * 100; i++){
		/* ե륤ǥåʳNULL */
		out.data[mgrDataNum].fileindex = i;
		out.data[mgrDataNum].work1 = 0;
		out.data[mgrDataNum].work2 = 0;
		memset(&(out.data[mgrDataNum].lang), NULL, DATA_LANG);
		memset(&(out.data[mgrDataNum].name), NULL, DATA_NAME);
		out.data[mgrDataNum].namelen = 0;
		memset(&(out.data[mgrDataNum].work3), NULL, DATA_WORK3);
		mgrDataNum++;
	}
	/* ե */
	if(outputFile(&(out), file, mgrFileNum) != TRUE){
		printf("MGRfile output Failed\n");
		return(1);
	}
	
	return(0);
	
}

/*-------------------------------------------
 * ե
 *   ꤵ줿ͤǥե˽Ϥ
 *-------------------------------------------*/
outputFile(mgrFile *out, fileInfo *file, int mgrFileNum){
	char outFilename[MAX_LEN];
	int out_FD;

	/* ե̾ */
	sprintf(outFilename, MGRFN, file->outputDirname, mgrFileNum);

	/* ץ */
	if((out_FD = creat(outFilename, PERMS)) == -1){
		printf("can't create file %s\n", outFilename);
		return(FALSE);
	}

	/* 񤭹 */
	if((write(out_FD, (char *)out, sizeof(mgrFile))) != sizeof(mgrFile)){
		printf("write error %s\n", outFilename);
		return(FALSE);
	}

	/*  */
	close(out_FD);
	return(TRUE);

}

/*----------------------------------------------
 * ǡ 
 *   եΥǡꤹ 
 *---------------------------------------------*/
int setMgrData(trackInfo *track, mgrData *data, int i){
	iconv_t cd;
	char *tptr;
	const char *fptr;
	size_t ileft, oleft, num, rtn;

	/*  */
	data->work1 = 0x00;
	data->work2 = 0x00;
	memset(data->lang, NULL, DATA_LANG);
	memset(data->name, NULL, DATA_NAME);
	memset(data->work3, NULL, sizeof(DATA_WORK3));

	/* ǥå */
	data->fileindex = i;

	/* ˥ԡǤΤΤꤹ */
	if(track->avail == TRUE){

		/*  */
		data->work1 = 0x01;
		data->work2 = 0x11;

		/*  */
		memcpy(data->lang, LANG, sizeof(LANG));

		/* ̾(UTF-8SJISѴԤ) */
		if(track->name != NULL &&
		   strlen(track->name) > 0 ){
			/* xmlե˶̾ͭä */
			cd = iconv_open("SJIS", "UTF-8");

			if(cd != (iconv_t)-1){
				/* ξΤѴԤ */
				fptr = track->name;
				tptr = data->name;
				ileft = (size_t)strlen(track->name);
				oleft = (size_t)DATA_NAME;
				rtn = iconv(cd, &fptr, &ileft, &tptr, &oleft);

				(void) iconv_close(cd);
			}

		} else {
			/* xmlե˶̵̾ä */
			memcpy(data->name, NONAME, sizeof(NONAME));
		}

		/* ̾Ĺ */
		data->namelen = strlen(data->name);

	}

	return(0);

}


/*---------------------------------------------
 * ʾ
 *   strtrackidȤnameȤartistȤ
 *   ΤäƤ鹽¤Τ˳Ǽ
 *   ֵ
 *---------------------------------------------*/
int getDetail(char *str, trackInfo *rtn){
	xmlValue xml;
	char     keyItem[MAX_LEN];
	char     location[MAX_LEN];


	if(getValue(str, TAG_KEY, &xml) != TRUE){
		return FALSE;
	}

	memset(&keyItem, NULL, sizeof(keyItem));
	memcpy(&keyItem, xml.value, strlen(xml.value));

	if(getValue(str, TAG_STRING, &xml) != TRUE){
		return FALSE;
	}

	/* ܤˤäƾǼʤˤ⤷ʤä */

	/* name */
	if(strcmp(keyItem, KEY_Name) == 0){
		rtn->name = (char *)malloc(strlen(xml.value) + 1);
		memset(rtn->name, NULL,      strlen(xml.value) +1);
		memcpy(rtn->name, xml.value, strlen(xml.value));
	}

	/* artist */
	else if(strcmp(keyItem, KEY_Artist) == 0){
		rtn->artist = (char *)malloc(strlen(xml.value) + 1);
		memset(rtn->artist, NULL,      strlen(xml.value) +1);
		memcpy(rtn->artist, xml.value, strlen(xml.value));
	}

	/* album */
	else if(strcmp(keyItem, KEY_Album) == 0){
		rtn->album = (char *)malloc(strlen(xml.value) +1);
		memset(rtn->album, NULL,      strlen(xml.value) +1);
		memcpy(rtn->album, xml.value, strlen(xml.value));
	}

	/* location */
	else if(strcmp(keyItem, KEY_Location) == 0){
		memcpy(location, xml.value, sizeof(xml.value));
		rtn->location = (char *)malloc(strlen(xml.value) + 1);
		memset(rtn->location, NULL,    strlen(xml.value) + 1);
		convLocation(location, rtn->location); 
	}

	/* other */
	else{
	;
	}

	return TRUE;

}

/*---------------------------------------------
 * LOCATION CONVERT
 *   LOCATIONѴ
 *---------------------------------------------*/
int convLocation(char *str, char *rtn){
	int i, j;
	char hex[3];
	char *endp;
	unsigned long workl;

	memset(hex, NULL, sizeof(hex));

	i = 0;
	j = 0;
	while(i < strlen(str)){
		/* %줿ɤ롩 */
		if(str[i] == '%'){
			hex[0] = str[i + 1];
			hex[1] = str[i + 2];
			workl = strtol((char*)hex, &endp, 16);
			rtn[j] = (char)workl;
			i = i + 3;
		}
		else{
			rtn[j] = str[i];
			i = i + 1;
		}

		j = j + 1;
	}

	return TRUE;


}



/*---------------------------------------------
 * 
 *   ͭ뤫ɤȽꤹ
 *   str椫tagǻꤵ줿¸ߤ
 *   TRUEֵѤ
 *   Ϥξ se = TS_START
 *   λξ se = TS_END
 *   ꤹ뤳
 *---------------------------------------------*/
int tagSearch(char *str, char *tag, char se){
	char tagstr[MAX_TAGLEN];

	memset(&tagstr, NULL, sizeof(tagstr));

	if(se == TS_START){
		sprintf(tagstr, "<%s>", tag);
	}else{
		sprintf(tagstr, "</%s>", tag);
	}

	if(strstr(str, tagstr) == NULL){
		return(FALSE);
	}else{
		return(TRUE);
	}

}


/*---------------------------------------------
 * value
 *    strΡtagǰϤޤ줿ͤrtn
 *    tag¸ߤʤ false ֵѤ
 *---------------------------------------------*/
int getValue(char *str, char *tag, xmlValue *rtn){
	char *s_start;
	char *s_end;
	int i_strlen;
	char tag_s[MAX_TAGLEN];
	char tag_e[MAX_TAGLEN];

	memset(&tag_s, NULL, sizeof(tag_s));
	memset(&tag_e, NULL, sizeof(tag_e));

	sprintf(tag_s, "<%s>", tag);
	sprintf(tag_e, "</%s>", tag);

	s_start = strstr(str, tag_s);
	s_end   = strstr(str, tag_e);

	if ( s_start == NULL || s_end == NULL ) {
		return(FALSE);
	}

	s_start = s_start + strlen(tag_s);
	i_strlen = s_end - s_start;

	memset(rtn->value, NULL, sizeof(rtn->value));
	memset(rtn->tag,   NULL, sizeof(rtn->value));

	memcpy(rtn->value, s_start, i_strlen);
	memcpy(rtn->tag,   tag, strlen(tag));

	return(TRUE);

}


